Package org.codehaus.janino

# Interface Visitor.RvalueVisitor<R,EX extends Throwable>

Type Parameters:
  `R` - The type of the object returned by the `visit*()` methods
  `EX` - The exception that the `visit*()` methods may throw

Enclosing class:
  `Visitor`

public static interface Visitor.RvalueVisitor<R,EX extends Throwable>
The visitor for all kinds of `Java.Rvalue`s.

## Method Summary

Modifier and Type
Method
Description
`R`
`visitArrayCreationReference(Java.ArrayCreationReference acr)`
Invoked by `Java.ArrayCreationReference.accept(Visitor.RvalueVisitor)`
`R`
`visitArrayLength(Java.ArrayLength al)`
Invoked by `Java.ArrayLength.accept(Visitor.RvalueVisitor)`
`R`
`visitAssignment(Java.Assignment a)`
Invoked by `Java.Assignment.accept(Visitor.RvalueVisitor)`
`R`
`visitBinaryOperation(Java.BinaryOperation bo)`
Invoked by `Java.BinaryOperation.accept(Visitor.RvalueVisitor)`
`R`
`visitBooleanLiteral(Java.BooleanLiteral bl)`
Invoked by `Java.BooleanLiteral.accept(Visitor.RvalueVisitor)`
`R`
`visitCast(Java.Cast c)`
Invoked by `Java.Cast.accept(Visitor.RvalueVisitor)`
`R`
`visitCharacterLiteral(Java.CharacterLiteral cl)`
Invoked by `Java.CharacterLiteral.accept(Visitor.RvalueVisitor)`
`R`
`visitClassLiteral(Java.ClassLiteral cl)`
Invoked by `Java.ClassLiteral.accept(Visitor.RvalueVisitor)`
`R`
`visitConditionalExpression(Java.ConditionalExpression ce)`
Invoked by `Java.ConditionalExpression.accept(Visitor.RvalueVisitor)`
`R`
`visitCrement(Java.Crement c)`
Invoked by `Java.Crement.accept(Visitor.RvalueVisitor)`
`R`
`visitFloatingPointLiteral(Java.FloatingPointLiteral fpl)`
Invoked by `Java.FloatingPointLiteral.accept(Visitor.RvalueVisitor)`
`R`
`visitInstanceCreationReference(Java.ClassInstanceCreationReference cicr)`
Invoked by `Java.ClassInstanceCreationReference.accept(Visitor.RvalueVisitor)`
`R`
`visitInstanceof(Java.Instanceof io)`
Invoked by `Java.Instanceof.accept(Visitor.RvalueVisitor)`
`R`
`visitIntegerLiteral(Java.IntegerLiteral il)`
Invoked by `Java.IntegerLiteral.accept(Visitor.RvalueVisitor)`
`R`
`visitLambdaExpression(Java.LambdaExpression le)`
Invoked by `Java.LambdaExpression.accept(Visitor.RvalueVisitor)`
`R`
`visitLvalue(Java.Lvalue lv)`
Invoked by `Java.Lvalue.accept(Visitor.RvalueVisitor)`
`R`
`visitMethodInvocation(Java.MethodInvocation mi)`
Invoked by `Java.MethodInvocation.accept(Visitor.RvalueVisitor)`
`R`
`visitMethodReference(Java.MethodReference mr)`
Invoked by `Java.MethodReference.accept(Visitor.RvalueVisitor)`
`R`
`visitNewAnonymousClassInstance(Java.NewAnonymousClassInstance naci)`
Invoked by `Java.NewAnonymousClassInstance.accept(Visitor.RvalueVisitor)`
`R`
`visitNewArray(Java.NewArray na)`
Invoked by `Java.NewArray.accept(Visitor.RvalueVisitor)`
`R`
`visitNewClassInstance(Java.NewClassInstance nci)`
Invoked by `Java.NewClassInstance.accept(Visitor.RvalueVisitor)`
`R`
`visitNewInitializedArray(Java.NewInitializedArray nia)`
Invoked by `Java.NewInitializedArray.accept(Visitor.RvalueVisitor)`
`R`
`visitNullLiteral(Java.NullLiteral nl)`
Invoked by `Java.NullLiteral.accept(Visitor.RvalueVisitor)`
`R`
`visitParameterAccess(Java.ParameterAccess pa)`
Invoked by `Java.ParameterAccess.accept(Visitor.RvalueVisitor)`
`R`
`visitQualifiedThisReference(Java.QualifiedThisReference qtr)`
Invoked by `Java.QualifiedThisReference.accept(Visitor.RvalueVisitor)`
`R`
`visitSimpleConstant(Java.SimpleConstant sl)`
Invoked by `Java.SimpleConstant.accept(Visitor.RvalueVisitor)`
`R`
`visitStringLiteral(Java.StringLiteral sl)`
Invoked by `Java.StringLiteral.accept(Visitor.RvalueVisitor)`
`R`
`visitSuperclassMethodInvocation(Java.SuperclassMethodInvocation smi)`
Invoked by `Java.SuperclassMethodInvocation.accept(Visitor.RvalueVisitor)`
`R`
`visitTextBlock(Java.TextBlock tb)`
Invoked by `Java.TextBlock.accept(Visitor.RvalueVisitor)`
`R`
`visitThisReference(Java.ThisReference tr)`
Invoked by `Java.ArrayLength.accept(Visitor.RvalueVisitor)`
`R`
`visitUnaryOperation(Java.UnaryOperation uo)`
Invoked by `Java.UnaryOperation.accept(Visitor.RvalueVisitor)`

## Method Details

### visitLvalue

@Nullable R visitLvalue(Java.Lvalue lv) throws EX
Invoked by `Java.Lvalue.accept(Visitor.RvalueVisitor)`

Throws:
  `EX`

### visitArrayLength

@Nullable R visitArrayLength(Java.ArrayLength al) throws EX
Invoked by `Java.ArrayLength.accept(Visitor.RvalueVisitor)`

Throws:
  `EX`

### visitAssignment

@Nullable R visitAssignment(Java.Assignment a) throws EX
Invoked by `Java.Assignment.accept(Visitor.RvalueVisitor)`

Throws:
  `EX`

### visitUnaryOperation

@Nullable R visitUnaryOperation(Java.UnaryOperation uo) throws EX
Invoked by `Java.UnaryOperation.accept(Visitor.RvalueVisitor)`

Throws:
  `EX`

### visitBinaryOperation

@Nullable R visitBinaryOperation(Java.BinaryOperation bo) throws EX
Invoked by `Java.BinaryOperation.accept(Visitor.RvalueVisitor)`

Throws:
  `EX`

### visitCast

@Nullable R visitCast(Java.Cast c) throws EX
Invoked by `Java.Cast.accept(Visitor.RvalueVisitor)`

Throws:
  `EX`

### visitClassLiteral

@Nullable R visitClassLiteral(Java.ClassLiteral cl) throws EX
Invoked by `Java.ClassLiteral.accept(Visitor.RvalueVisitor)`

Throws:
  `EX`

### visitConditionalExpression

@Nullable R visitConditionalExpression(Java.ConditionalExpression ce) throws EX
Invoked by `Java.ConditionalExpression.accept(Visitor.RvalueVisitor)`

Throws:
  `EX`

### visitCrement

@Nullable R visitCrement(Java.Crement c) throws EX
Invoked by `Java.Crement.accept(Visitor.RvalueVisitor)`

Throws:
  `EX`

### visitInstanceof

@Nullable R visitInstanceof(Java.Instanceof io) throws EX
Invoked by `Java.Instanceof.accept(Visitor.RvalueVisitor)`

Throws:
  `EX`

### visitMethodInvocation

@Nullable R visitMethodInvocation(Java.MethodInvocation mi) throws EX
Invoked by `Java.MethodInvocation.accept(Visitor.RvalueVisitor)`

Throws:
  `EX`

### visitSuperclassMethodInvocation

@Nullable R visitSuperclassMethodInvocation(Java.SuperclassMethodInvocation smi) throws EX
Invoked by `Java.SuperclassMethodInvocation.accept(Visitor.RvalueVisitor)`

Throws:
  `EX`

### visitIntegerLiteral

@Nullable R visitIntegerLiteral(Java.IntegerLiteral il) throws EX
Invoked by `Java.IntegerLiteral.accept(Visitor.RvalueVisitor)`

Throws:
  `EX`

### visitFloatingPointLiteral

@Nullable R visitFloatingPointLiteral(Java.FloatingPointLiteral fpl) throws EX
Invoked by `Java.FloatingPointLiteral.accept(Visitor.RvalueVisitor)`

Throws:
  `EX`

### visitBooleanLiteral

@Nullable R visitBooleanLiteral(Java.BooleanLiteral bl) throws EX
Invoked by `Java.BooleanLiteral.accept(Visitor.RvalueVisitor)`

Throws:
  `EX`

### visitCharacterLiteral

@Nullable R visitCharacterLiteral(Java.CharacterLiteral cl) throws EX
Invoked by `Java.CharacterLiteral.accept(Visitor.RvalueVisitor)`

Throws:
  `EX`

### visitStringLiteral

@Nullable R visitStringLiteral(Java.StringLiteral sl) throws EX
Invoked by `Java.StringLiteral.accept(Visitor.RvalueVisitor)`

Throws:
  `EX`

### visitTextBlock

@Nullable R visitTextBlock(Java.TextBlock tb) throws EX
Invoked by `Java.TextBlock.accept(Visitor.RvalueVisitor)`

Throws:
  `EX`

### visitNullLiteral

@Nullable R visitNullLiteral(Java.NullLiteral nl) throws EX
Invoked by `Java.NullLiteral.accept(Visitor.RvalueVisitor)`

Throws:
  `EX`

### visitSimpleConstant

@Nullable R visitSimpleConstant(Java.SimpleConstant sl) throws EX
Invoked by `Java.SimpleConstant.accept(Visitor.RvalueVisitor)`

Throws:
  `EX`

### visitNewAnonymousClassInstance

@Nullable R visitNewAnonymousClassInstance(Java.NewAnonymousClassInstance naci) throws EX
Invoked by `Java.NewAnonymousClassInstance.accept(Visitor.RvalueVisitor)`

Throws:
  `EX`

### visitNewArray

@Nullable R visitNewArray(Java.NewArray na) throws EX
Invoked by `Java.NewArray.accept(Visitor.RvalueVisitor)`

Throws:
  `EX`

### visitNewInitializedArray

@Nullable R visitNewInitializedArray(Java.NewInitializedArray nia) throws EX
Invoked by `Java.NewInitializedArray.accept(Visitor.RvalueVisitor)`

Throws:
  `EX`

### visitNewClassInstance

@Nullable R visitNewClassInstance(Java.NewClassInstance nci) throws EX
Invoked by `Java.NewClassInstance.accept(Visitor.RvalueVisitor)`

Throws:
  `EX`

### visitParameterAccess

@Nullable R visitParameterAccess(Java.ParameterAccess pa) throws EX
Invoked by `Java.ParameterAccess.accept(Visitor.RvalueVisitor)`

Throws:
  `EX`

### visitQualifiedThisReference

@Nullable R visitQualifiedThisReference(Java.QualifiedThisReference qtr) throws EX
Invoked by `Java.QualifiedThisReference.accept(Visitor.RvalueVisitor)`

Throws:
  `EX`

### visitThisReference

@Nullable R visitThisReference(Java.ThisReference tr) throws EX
Invoked by `Java.ArrayLength.accept(Visitor.RvalueVisitor)`

Throws:
  `EX`

### visitLambdaExpression

@Nullable R visitLambdaExpression(Java.LambdaExpression le) throws EX
Invoked by `Java.LambdaExpression.accept(Visitor.RvalueVisitor)`

Throws:
  `EX`

### visitMethodReference

@Nullable R visitMethodReference(Java.MethodReference mr) throws EX
Invoked by `Java.MethodReference.accept(Visitor.RvalueVisitor)`

Throws:
  `EX`

### visitInstanceCreationReference

@Nullable R visitInstanceCreationReference(Java.ClassInstanceCreationReference cicr) throws EX
Invoked by `Java.ClassInstanceCreationReference.accept(Visitor.RvalueVisitor)`

Throws:
  `EX`

### visitArrayCreationReference

@Nullable R visitArrayCreationReference(Java.ArrayCreationReference acr) throws EX
Invoked by `Java.ArrayCreationReference.accept(Visitor.RvalueVisitor)`

Throws:
  `EX`